package viewer.graph.rna;

import tools3d.objects3d.Object3D;
import viewer.graph.CacheableObject3DRenderableGraph;
import viewer.graphics.AdvancedMesh;
import viewer.graphics.DefaultAdvancedMesh;
import rnadesign.rnamodel.BranchDescriptor3D;

/**
 * This is the abstract class for anything that
 * can render an atom. It serves mainly as a marker
 * but also allows access to the underlying Atom.
 * @author Calvin
 *
 */
public abstract class BranchDescriptorRendererGraph extends CacheableObject3DRenderableGraph {
    public BranchDescriptorRendererGraph(BranchDescriptor3D object) {
	super(object);
    }
    
    /**
     * Get the branch descriptor
     * @return Returns the branch descriptor this graph renders
     */
    public BranchDescriptor3D getBranchDescriptor() {
	return (BranchDescriptor3D) getObject();
    }
	
	


}
